import java.awt.*;
import java.io.*;
import java.applet.*;
import java.net.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.*;
public class ActionPool extends JApplet implements Runnable,ActionListener,KeyListener,MouseListener{
    Thread t;
    JPanel p;
    GameActionPool q;
    Vector<String> lcontent;
    JList<String> l;
    JScrollPane spl;
    JButton b;
    boolean startg=false;
    boolean running=true;
    static ActionPool app;
    private static final long serialVersionUID = -446230697542412998L;
    public void init(){
        app=this;
        setLayout(null);
        lcontent=new Vector<String>();
        l=new JList<String>(lcontent);
        spl=new JScrollPane(l);
        b=new JButton("start");
        p=new JPanel();
        p.setLayout(null);
        p.add(spl);
        p.add(b);
        add(p);
        p.setBounds(0,0,640,520);
        spl.setBounds(10,40,280,300);
        b.setBounds(10,350,280,27);
        b.addActionListener(this);
        loadLevs();
        setVisible(true);
        setFocusable(true);
        requestFocus();
        addKeyListener(this);
        addMouseListener(this);
        t=new Thread(this);
        t.start();
    }
    public void loadLevs(){
        try{
            InputStream is=getClass().getResourceAsStream("/levs.ini");
//            FileInputStream is=new FileInputStream("levs.ini");
            BufferedReader dis=new BufferedReader(new InputStreamReader(is));
            String inp="";
            while((inp=dis.readLine())!=null){
                lcontent.addElement(inp);
            }
            is.close();
            l.setListData(lcontent);
        }
        catch(Exception e){
            e.printStackTrace(System.out);
        }
    }
    public void run(){
        while(running){
            try{
                if(startg){
                    startg=false;
                    int ind=l.getSelectedIndex();
                    if(ind!=-1&&ind<lcontent.size()){
                        if(q!=null){
                            remove(q);
                        }
                        q=new GameActionPool(this,lcontent.elementAt(ind));
                        p.setVisible(false);
                        add(q);
                        q.setBounds(0,0,640,480);
                    }
                }
                Thread.sleep(100);
            }
            catch(Exception e){
                e.printStackTrace(System.out);
            }
        }
    }
    public static void main(String[]args){
//        new ActionPool();
    }
    public void actionPerformed(ActionEvent evt){
            if(evt.getSource()==b){
                startg=true;
            }
    }
    public void keyTyped(KeyEvent e){
    }
    public void keyPressed(KeyEvent e){
        requestFocus();
        if(q!=null){
            q.process(e);
        }
    }
    public void keyReleased(KeyEvent e){
    }
    public void mousePressed(MouseEvent me) {
        requestFocus();
        if(q!=null){
            q.mprocess(me);
        }
    }
    public void mouseReleased(MouseEvent e) {
    }
    public void mouseEntered(MouseEvent e) {
    }
    public void mouseExited(MouseEvent e) {
    }
    public void mouseClicked(MouseEvent e) {
    }
}
class GameActionPool extends JPanel{
    XCanvasActionPool xc;
    ActionPool ap;
    String level;
    int[][]screen=new int[30][18];
    static Image background;
    static Image stone;
    static Image pickup;
    static Image boule;
    static Image absorber;
    static Image hole;
    int mclickx1=0;
    int mclicky1=0;
    int mclickx2=0;
    int mclicky2=0;
    MediaTracker tracker;
    boolean firstclicked=false;
    private static final long serialVersionUID = 6281534847565304206L;
    public GameActionPool(ActionPool ap,String level){
        setSize(640,520);
        setLayout(null);
        this.ap=ap;
        this.level=level;
        if(background==null){
            loadImgs();
        }
        loadLev();
        xc=new XCanvasActionPool(this);
        add(xc);
        xc.setBounds(0,40,640,480);
        setVisible(true);
    }
    public void process(KeyEvent evt){
        int key=evt.getKeyCode();
        if(key==27||key==KeyEvent.VK_ESCAPE){
            setVisible(false);
            ap.p.setVisible(true);
        }
    }
    public void mprocess(MouseEvent me){
        if(xc!=null){
            xc.mprocess(me);
        }
    }
    public static Image getImage(String filename){
        try{
            URL url=ActionPool.app.getClass().getResource("/"+filename);
            Image img=ActionPool.app.getToolkit().getImage(url);
            return img;
        }
        catch(Exception e){
        }
        return null;
    }
    public void loadImgs(){
        try{
            background=getImage("background.gif");
            stone=getImage("stone.gif");
            pickup=getImage("pickup.gif");
            boule=getImage("boule.gif");
            absorber=getImage("absorber.gif");
            hole=getImage("hole.gif");
            tracker=new MediaTracker(this);
            tracker.addImage(background,0);
            tracker.addImage(stone,0);
            tracker.addImage(pickup,0);
            tracker.addImage(boule,0);
            tracker.addImage(absorber,0);
            tracker.addImage(hole,0);
            tracker.waitForID(0);
        }
        catch(Exception e){
        }
    }
    public void loadLev(){
        try{
            InputStream is=getClass().getResourceAsStream("/"+level);
//            FileInputStream is=new FileInputStream(level);
            for(int i=0;i<30;i++){
                for(int j=0;j<18;j++){
                    screen[i][j]=is.read();
                }
            }
            is.close();
        }
        catch(Exception e){
        }
    }
}
class ImFrameActionPool extends JFrame{
    Image img;
    private static final long serialVersionUID = 6073977972254617223L;
    public ImFrameActionPool(){
        pack();
        img=createImage(640,480);
    }
}
class XCanvasActionPool extends JPanel implements Runnable{
    Image img;
    GameActionPool game;
    Graphics h;
    int[][]screen;
    Thread t;
    boolean running=true;
    int pickups=0;
    int ballsingame=0;
    int ballsinhole=0;
    int ballssaved=0;
    BallHolder bh;
    private static final long serialVersionUID = -6709247526821465991L;
    public XCanvasActionPool(GameActionPool game){
        this.game=game;
        bh=new BallHolder();
        screen=game.screen;
        for(int i=0;i<30;i++){
            for(int j=0;j<18;j++){
                if(screen[i][j]==2){
                    pickups++;
                }
                if(screen[i][j]==6){
                    double alpha=Math.random()*Math.PI*2;
                    double xdrift=Math.cos(alpha)*3;
                    double ydrift=Math.sin(alpha)*3;
                    Ball b=new Ball(i*20+10,j*20+10,xdrift,ydrift,false);
                    bh.add(b);
                    ballsingame++;
                    screen[i][j]=0;
                }
            }
        }
        ImFrameActionPool im=new ImFrameActionPool();
        img=im.img;
        h=img.getGraphics();
        t=new Thread(this);
        t.start();
    }
    public void run(){
        while(running){
            try{
                repaint();
                Thread.sleep(100);
            }
            catch(Exception e){
            }
        }
    }
    public synchronized void mprocess(MouseEvent me){
            int x=me.getX()-20;
            int y=me.getY()-80;
            if(x>=0&&y>=0&&x<640&&y<480&&!game.firstclicked){
                game.firstclicked=true;
                game.mclickx1=x;
                game.mclicky1=y;
            }
            else if(x>=0&&y>=0&&x<640&&y<480&&game.firstclicked&&!(x==game.mclickx1)&&!(y==game.mclicky1)){
                game.firstclicked=false;
                game.mclickx2=x;
                game.mclicky2=y;
                int diffx=game.mclickx2-game.mclickx1;
                int diffy=game.mclicky2-game.mclicky1;
                double diffl=Math.sqrt(diffx*diffx+diffy*diffy);
                Ball b=new Ball(game.mclickx1,game.mclicky1,diffx/diffl*3,diffy/diffl*3,true);
                bh.add(b);
            }
            else{
                game.firstclicked=false;
            }
    }
//    public void paint(Graphics g){
//    }
    public synchronized void paint(Graphics g){
        h.setColor(Color.black);
        h.fillRect(0,0,640,480);
        Stone[][]stone=new Stone[30][18];
        for(int i=0;i<30;i++){
            for(int j=0;j<18;j++){
                if(screen[i][j]==0){
                    h.drawImage(GameActionPool.background,i*20+20,j*20+40,this);
                }
                else if(screen[i][j]==1){
                    h.drawImage(GameActionPool.stone,i*20+20,j*20+40,this);
                    stone[i][j]=getStone(i,j,1);
                }
                else if(screen[i][j]==2){
                    h.drawImage(GameActionPool.pickup,i*20+20,j*20+40,this);
                }
                else if(screen[i][j]==3){
                    h.drawImage(GameActionPool.boule,i*20+20,j*20+40,this);
                }
                else if(screen[i][j]==4){
                    h.drawImage(GameActionPool.absorber,i*20+20,j*20+40,this);
                }
                else if(screen[i][j]==5){
                    h.drawImage(GameActionPool.hole,i*20+20,j*20+40,this);
                }
            }
        }
        BallHolder bh2=new BallHolder();
        for(int k=0;k<bh.ball.length;k++){
            double xpos=bh.ball[k].x;
            double ypos=bh.ball[k].y;
            double xdrift=bh.ball[k].xdrift;
            double ydrift=bh.ball[k].ydrift;
            Side ballside=new Side(bh.ball[k].x,bh.ball[k].y,bh.ball[k].x+bh.ball[k].xdrift,bh.ball[k].y+bh.ball[k].ydrift);
            PointHolder ph=new PointHolder();
            for(int i=0;i<30;i++){
                for(int j=0;j<18;j++){
                    if(stone[i][j]!=null){
                        Stone cs=stone[i][j];
                        Point p1=cs.s1.cut(ballside);
                        if(p1.r>0&&p1.r<1&&p1.s>0&&p1.s<1){
                            ph.add(p1);
                        }
                        Point p2=cs.s2.cut(ballside);
                        if(p2.r>0&&p2.r<1&&p2.s>0&&p2.s<1){
                            ph.add(p2);
                        }
                        Point p3=cs.s3.cut(ballside);
                        if(p3.r>0&&p3.r<1&&p3.s>0&&p3.s<1){
                            ph.add(p3);
                        }
                        Point p4=cs.s4.cut(ballside);
                        if(p4.r>0&&p4.r<1&&p4.s>0&&p4.s<1){
                            ph.add(p4);
                        }
                    }
                }
            }
            double lb=1;
            Point p=null;
            int n=ph.points.length;
            for(int i=0;i<n;i++){
                if(ph.points[i].s<lb){
                    p=ph.points[i];
                    lb=ph.points[i].s;
                }
            }
            double ax=xpos;
            double ay=ypos;
            boolean stopped=false;
            boolean schraeg=false;
            int points=0;
            if(p!=null){
                Side s=p.target;
                Side normal=s.getNormal();
                Side base=new Side(p.x,p.y,s.x2,s.y2);
                Point tar=new Point(xpos,ypos);
                Point coord=base.getCoord(tar,normal);
                if(coord.x==-1&&coord.y==-1){
                }
                else{
                    double len2=Math.sqrt((xpos-p.x)*(xpos-p.x)+(ypos-p.y)*(ypos-p.y));
                    double xposb=-coord.x*(s.x2-p.x)+coord.y*(normal.x2-normal.x1);
                    double yposb=-coord.x*(s.y2-p.y)+coord.y*(normal.y2-normal.y1);
                    if(s!=null&&s.stone!=null){
                        points=points+s.stone.value;
                    }
                    double len=Math.sqrt(xposb*xposb+yposb*yposb);
                    double lendrift=Math.sqrt(xdrift*xdrift+ydrift*ydrift);
                    double len3=lendrift-len2;
                    if(!stopped){
                        bh.ball[k].x=p.x+xposb*len3/len;
                        bh.ball[k].y=p.y+yposb*len3/len;
                        bh.ball[k].xdrift=xposb/len*3;
                        bh.ball[k].ydrift=yposb/len*3;
                    }
                    schraeg=true;
                }
            }
            if(!schraeg){
                bh.ball[k].x=bh.ball[k].x+bh.ball[k].xdrift;
                bh.ball[k].y=bh.ball[k].y+bh.ball[k].ydrift;
            }
            int xd=(int)bh.ball[k].x/20;
            int yd=(int)bh.ball[k].y/20;
            if(bh.ball[k].x<0||bh.ball[k].y<0||bh.ball[k].x>=600||bh.ball[k].y>=360){
                bh.ball[k].removed=true;
                if(!bh.ball[k].kugel){
                    ballsingame--;
                }
            }
            else{
                for(int l=0;l<bh.ball.length;l++){
                    if(l!=k){
                        if(bh.ball[k].kugel&&!bh.ball[l].kugel){
                            double entfk=Math.sqrt((bh.ball[k].x-bh.ball[l].x)*(bh.ball[k].x-bh.ball[l].x)+(bh.ball[k].y-bh.ball[l].y)*(bh.ball[k].y-bh.ball[l].y));
                            if(entfk<12){
                                bh.ball[l].xdrift=bh.ball[k].xdrift;
                                bh.ball[l].ydrift=bh.ball[k].ydrift;
                                double lenb=Math.sqrt(bh.ball[l].xdrift*bh.ball[l].xdrift+bh.ball[l].ydrift*bh.ball[l].ydrift);
                                bh.ball[l].xdrift=bh.ball[l].xdrift/lenb*3;
                                bh.ball[l].ydrift=bh.ball[l].ydrift/lenb*3;
                                bh.ball[k].removed=true;
                            }
                        }
                    }
                }
                int sc=screen[xd][yd];
                if(sc==4){
                    if(!bh.ball[k].kugel){
                        ballsingame--;
                    }
                    bh.ball[k].removed=true;
                }
                else if(sc==5){
                    if(!bh.ball[k].kugel){
                        ballsingame--;
                        ballssaved++;
                    }
                    bh.ball[k].removed=true;
                }
                else if(sc==3){
                    if(bh.ball[k].kugel){
                        bh.ball[k].removed=true;
                    }
                    else{
                        double alpha=Math.random()*Math.PI*2;
                        ballsingame++;
                        Ball b=new Ball(xd*20+10,yd*20+10,Math.sin(alpha)*3,Math.cos(alpha)*3,false);
                        bh2.add(b);
                        screen[xd][yd]=0;
                    }
                }
                else if(sc==2){
                    if(bh.ball[k].kugel){
                        bh.ball[k].removed=true;
                    }
                    else{
                        pickups--;
                        screen[xd][yd]=0;
                    }
                }
            }
        }
        int cur=0;
        while(cur<bh.ball.length){
            if(bh.ball[cur].removed){
                bh.remove(bh.ball[cur]);
            }
            cur++;
        }
        for(int i=0;i<bh2.ball.length;i++){
            bh.add(bh2.ball[i]);
        }
        for(int i=0;i<bh.ball.length;i++){
            if(!bh.ball[i].kugel){
                h.setColor(Color.blue);
                h.fillOval(20+(int)bh.ball[i].x-10,40+(int)bh.ball[i].y-10,20,20);
            }
            else{
                h.setColor(Color.red);
                h.fillOval(20+(int)bh.ball[i].x-5,40+(int)bh.ball[i].y-5,10,10);
            }
        }
        h.setColor(Color.red);
        if(pickups<=0&&ballsingame<=0){
            h.drawString("You have won! balls saved: "+ballssaved,100,20);
        }
        else{
            if(ballsingame<=0){
                h.drawString("You have lost!",100,20);
            }
            else{
                h.drawString("Pickups: "+pickups+" balls in game: "+ballsingame+" balls saved: "+ballssaved,100,20);
            }
        }
        g.drawImage(img,0,0,this);
//        paint(g);
    }
    public synchronized Stone getStone(int i,int j,int num){
        double xleft=i*20;
        double yleft=j*20;
        Side s1=new Side(xleft,yleft,xleft+20,yleft+0);
        Side s2=new Side(xleft+20,yleft,xleft+20,yleft+20);
        Side s3=new Side(xleft+20,yleft+20,xleft+0,yleft+20);
        Side s4=new Side(xleft,yleft+20,xleft+0,yleft+0);
        Stone s=new Stone(num,s1,s2,s3,s4);
        s1.stone=s;
        s2.stone=s;
        s3.stone=s;
        s4.stone=s;
        return s;
    }
}
class BallHolder{
    Ball[]ball=new Ball[0];
    public BallHolder(){
    }
    public void add(Ball b){
        int n=ball.length;
        Ball[]ball2=new Ball[n+1];
        for(int i=0;i<n;i++){
            ball2[i]=ball[i];
        }
        ball2[n]=b;
        ball=ball2;
    }
    public void remove(Ball b){
        int n=ball.length;
        Ball[]ball2=new Ball[n-1];
        int c=0;
        for(int i=0;i<n;i++){
            if(ball[i]==b){
            }
            else{
                ball2[c]=ball[i];
                c++;
            }
        }
        ball=ball2;
    }
}
class Ball{
    double x;
    double y;
    double xdrift;
    double ydrift;
    boolean removed=false;
    boolean kugel=false;
    public Ball(double x,double y,double xdrift,double ydrift,boolean kugel){
        this.x=x;
        this.y=y;
        this.xdrift=xdrift;
        this.ydrift=ydrift;
        this.kugel=kugel;
    }
}
class PointHolder{
    Point[]points=new Point[0];
    public PointHolder(){
    }
    public void add(Point p){
        int n=points.length;
        Point[]points2=new Point[n+1];
        for(int i=0;i<n;i++){
            points2[i]=points[i];
        }
        points2[n]=p;
        points=points2;
    }
}
class Stone{
    int value;
    Side s1;
    Side s2;
    Side s3;
    Side s4;
    public Stone(int value,Side s1,Side s2,Side s3,Side s4){
        this.value=value;
        this.s1=s1;
        this.s2=s2;
        this.s3=s3;
        this.s4=s4;
    }
}
class Side{
    double x1;
    double x2;
    double y1;
    double y2;
    Stone stone;
    public Side(double x1,double y1,double x2,double y2){
        this.x1=x1;
        this.y1=y1;
        this.x2=x2;
        this.y2=y2;
    }
    public Side(double x1,double y1,double x2,double y2,Stone stone){
        this.x1=x1;
        this.y1=y1;
        this.x2=x2;
        this.y2=y2;
        this.stone=stone;
    }
    public Side getNormal(){
        double a=x2-x1;
        double b=y2-y1;
        double c=1;
        double d=0;
        if(b!=0){
            d=-a/b;
        }
        else{
            c=0;
            d=1;
        }
        Side ret=new Side(x1,y1,x1+c,y1+d);
        return ret;
    }
    public Point getCoord(Point point,Side b){
        double[][]matrix=new double[3][2];
        matrix[0][0]=x2-x1;
        matrix[0][1]=y2-y1;
        matrix[1][0]=b.x2-b.x1;
        matrix[1][1]=b.y2-b.y1;
        matrix[2][0]=point.x-x1;
        matrix[2][1]=point.y-y1;
        if(matrix[0][0]==0){
            double[][]matrix2=new double[3][2];
            matrix2[0][0]=matrix[0][1];
            matrix2[0][1]=matrix[0][0];
            matrix2[1][0]=matrix[1][1];
            matrix2[1][1]=matrix[1][0];
            matrix2[2][0]=matrix[2][1];
            matrix2[2][1]=matrix[2][0];
            matrix=matrix2;
        }
        if(matrix[0][0]==0){
            return new Point(-1,-1);
        }
        double coeff=matrix[0][1]/matrix[0][0];
        matrix[0][1]=matrix[0][1]-coeff*matrix[0][0];
        matrix[1][1]=matrix[1][1]-coeff*matrix[1][0];
        matrix[2][1]=matrix[2][1]-coeff*matrix[2][0];
        if(matrix[1][1]==0){
            return new Point(-1,-1);
        }
        double s=matrix[2][1]/matrix[1][1];
        double r=(matrix[2][0]-matrix[1][0]*s)/matrix[0][0];
        return new Point(r,s);
    }
    public Point cut(Side b){
        double[][]matrix=new double[3][2];
        matrix[0][0]=x2-x1;
        matrix[0][1]=y2-y1;
        matrix[1][0]=-(b.x2-b.x1);
        matrix[1][1]=-(b.y2-b.y1);
        matrix[2][0]=-x1+b.x1;
        matrix[2][1]=-y1+b.y1;
        if(matrix[0][0]==0){
            double[][]matrix2=new double[3][2];
            matrix2[0][0]=matrix[0][1];
            matrix2[0][1]=matrix[0][0];
            matrix2[1][0]=matrix[1][1];
            matrix2[1][1]=matrix[1][0];
            matrix2[2][0]=matrix[2][1];
            matrix2[2][1]=matrix[2][0];
            matrix=matrix2;
        }
        if(matrix[0][0]==0){
            return new Point(-1,-1);
        }
        double coeff=matrix[0][1]/matrix[0][0];
        matrix[0][1]=matrix[0][1]-coeff*matrix[0][0];
        matrix[1][1]=matrix[1][1]-coeff*matrix[1][0];
        matrix[2][1]=matrix[2][1]-coeff*matrix[2][0];
        if(matrix[1][1]==0){
            return new Point(-1,-1);
        }
        double s=matrix[2][1]/matrix[1][1];
        double r=(matrix[2][0]-matrix[1][0]*s)/matrix[0][0];
        return new Point(x1+r*(x2-x1),y1+r*(y2-y1),r,s,this);
    }
}
class Point{
    double x;
    double y;
    double r;
    double s;
    Side target;
    public Point(double x,double y){
        this.x=x;
        this.y=y;
        r=-1;
        s=-1;
    }
    public Point(double x,double y,double r,double s,Side target){
        this.x=x;
        this.y=y;
        this.r=r;
        this.s=s;
        this.target=target;
    }
}
