import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import java.io.*;
import java.net.*;
public class TunnelApplication extends JFrame implements Runnable,KeyListener{
    EngineTunnel eng;
    Thread t;
    Vektor poser;
    private static final long serialVersionUID = 2462202588880817272L;
    public TunnelApplication(){
        super("Astro Solutions Tunnel");
        pack();
        setSize(440,480);
        eng=new EngineTunnel();
        add(eng);
        eng.setBounds(0,40,400,400);
        newTunnel();
        poser=new Vektor(-3,0,0);
        t=new Thread(this);
        setVisible(true);
        setFocusable(true);
        requestFocus();
        addKeyListener(this);
        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        t.start();
    }
    public static void main(String[]args){
        new TunnelApplication();
    }
    public synchronized void newTunnel(){
        Vektor pos=new Vektor(0,0,0);
        Vektor forward=new Vektor(20,0,0);
        Vektor right=new Vektor(0,35,0);
        Vektor up=new Vektor(0,0,35);
        Vektor[]first=getRound(pos,right,up);
        Vektor[]second;
        for(int i=0;i<10;i++){
            pos.x=pos.x+forward.x;
            second=getRound(pos,right,up);
            consElem(first,second,""+i);
            first=second;
        }
        for(int i=10;i<80;i++){
            int j=(int)(Math.random()*6);
            if(j<2){
                pos.transform(forward.x,forward.y,forward.z);
            }
            if(j==2){
                forward.rotUp(Math.PI/20);
                up.rotUp(Math.PI/20);
                right.rotUp(Math.PI/20);
                pos.transform(forward.x,forward.y,forward.z);
            }
            if(j==3){
                forward.rotUp(-Math.PI/20);
                up.rotUp(-Math.PI/20);
                right.rotUp(-Math.PI/20);
                pos.transform(forward.x,forward.y,forward.z);
            }
            if(j==4){
                forward.rotLeft(Math.PI/20);
                up.rotLeft(Math.PI/20);
                right.rotLeft(Math.PI/20);
                pos.transform(forward.x,forward.y,forward.z);
            }
            if(j==5){
                forward.rotLeft(-Math.PI/20);
                up.rotLeft(-Math.PI/20);
                right.rotLeft(-Math.PI/20);
                pos.transform(forward.x,forward.y,forward.z);
            }
            second=getRound(pos,right,up);
            consElem(first,second,""+i);
            first=second;
        }
    }
    public void consElem(Vektor[]a,Vektor[]b,String pos){
        for(int i=0;i<20;i++){
            Vektor v1=a[i].cloneo();
            Polygon p=new Polygon(new Color((int)(Math.random()*2550)),v1);
            p.addpoint(b[i].cloneo());
            p.addpoint(b[(i+1)%20].cloneo());
            p.addpoint(a[(i+1)%20].cloneo());
            eng.addPolygon(pos,p);
        }
    }
    public Vektor[] getRound(Vektor pos,Vektor right,Vektor up){
        double win=0;
        Vektor[]verk=new Vektor[20];
        for(int i=0;i<20;i++){
            double sinw=Math.sin(win);
            double cosw=Math.cos(win);
            verk[i]=new Vektor(pos.x+right.x*cosw+up.x*sinw,pos.y+right.y*cosw+up.y*sinw,pos.z+right.z*cosw+up.z*sinw);
            win+=Math.PI/10;
        }
        return verk;
    }
    public void run(){
        try{
            while(true){
                eng.transform(poser.x,poser.y,poser.z);
                Thread.sleep(100);
            }
        }
        catch(Exception e){};
    }
    public void keyTyped(KeyEvent e){
    }
    public void keyPressed(KeyEvent e){
        requestFocus();
        process(e);
//System.out.println("kpressed"+key);
    }
    public void keyReleased(KeyEvent e){
    }
    public void process(KeyEvent evt){
        int key=evt.getKeyCode();
        if(key==KeyEvent.VK_UP){
            eng.rotUp(Math.PI/90);
        }
        if(key==KeyEvent.VK_DOWN){
            eng.rotUp(-Math.PI/90);
        }
        if(key==KeyEvent.VK_LEFT){
            eng.rotLeft(Math.PI/90);
        }
        if(key==KeyEvent.VK_RIGHT){
            eng.rotLeft(-Math.PI/90);
        }
        if(key==KeyEvent.VK_DELETE){
            poser.x=poser.x*9/10;
            poser.y=poser.y*9/10;
            poser.z=poser.z*9/10;
        }
        if(key==KeyEvent.VK_INSERT){
            poser.x=poser.x*10/9;
            poser.y=poser.y*10/9;
            poser.z=poser.z*10/9;
        }
    }
}
class LoadGroups{
    TunnelApplication dw;
    public LoadGroups(TunnelApplication dw){
        this.dw=dw;
    }
    public Group loadGroup(String file){
        Vektor v=new Vektor(0,0,0);
        Polygon p2=new Polygon(new Color(0),v);
        Group ret=new Group(p2);
        try{
            FileInputStream fos=new FileInputStream(file);
//            InputStream fos = new URL(dw.getDocumentBase(),file).openStream();
            BufferedReader dis=new BufferedReader(new InputStreamReader(fos));
            String h=dis.readLine();
            String f=null;
            boolean first=true;
            while((f=dis.readLine())!=null){
                int points=new Integer(f).intValue();     
                Polygon p=loadPolygon(dis,points);
                if(first){
                    first=false;
                    ret=new Group(p);
                }
                else ret.addpol(p);
            }
            dis.close();
            fos.close();
        }
        catch(Exception e){};
        return ret;
    }
    public Polygon loadPolygon(BufferedReader dis,int points){
        Polygon p=null;
        try{
            int color=new Integer(dis.readLine()).intValue();
            int x=new Integer(dis.readLine()).intValue();
            int y=new Integer(dis.readLine()).intValue();
            int z=new Integer(dis.readLine()).intValue();
            p=new Polygon(new Color(color),new Vektor(x,y,z));
            for(int i=0;i<points-1;i++){
                int x2=new Integer(dis.readLine()).intValue();
                int y2=new Integer(dis.readLine()).intValue();
                int z2=new Integer(dis.readLine()).intValue();
                p.addpoint(new Vektor(x2,y2,z2));
            }
        }
        catch(Exception e){};
        return p;
    }
}
class EngineTunnel extends JPanel implements Runnable{
    Thread t;
    ImageFrameTunnel imf;
    Image img;
    Graphics h;
    Kugels headk;
    Kugels currentk;
    Groups headg;
    Groups currentg;
    Polygons headp;
    Polygons currentp;
    int co=0;
    String status="";
    boolean running=true;
    private static final long serialVersionUID = -4082207460508826555L;
    class Veks{
        Veks next;
        Vektor data;
        Kugel k;
        public Veks(Vektor data){
            this.data=data;
        }
    }
    class Pols{
        Pols next;
        Veks data;
        Color col;
        Veks head;
        public Pols(Veks data,Color col){
            this.data=data;
            this.col=col;
            head=data;
        }
    }
    class Kugels{
        String name;
        Kugel k;
        Kugels next;
        public Kugels(String a,Kugel b){
            name=a;
            k=b;
        }
        public String getName(){
            return name;
        }
        public Kugel getKugel(){
            return k;
        }
        public Kugels next(){
            return next;
        }
    }
    class Groups{
        String name;
        Group g;
        Groups next;
        int elim=0;
        public Groups(String a,Group b){
            name=a;
            g=b;
        }
        public String getName(){
            return name;
        }
        public Group getGroup(){
            return g;
        }
        public Groups next(){
            return next;
        }
    }
    class Polygons{
        String name;
        Polygon p;
        Polygons next;
        public Polygons(String a,Polygon b){
            name=a;
            p=b;
        }
        public String getName(){
            return name;
        }
        public Polygon getPolygon(){
            return p;
        }
        public Polygons next(){
            return next;
        }
    }
    public EngineTunnel(){
        imf=new ImageFrameTunnel();
        img=imf.img;
        h=img.getGraphics();
        t=new Thread(this);
        t.start();
    }
    public synchronized void addKugel(String name,Kugel k){
        if(currentk==null){
            currentk=new Kugels(name,k);
            headk=currentk;
        }
        else{
            currentk.next=new Kugels(name,k);
            currentk=currentk.next;
        }
    }
    public synchronized void addGroup(String name,Group k){
        if(currentg==null){
            currentg=new Groups(name,k);
            headg=currentg;
        }
        else{
            currentg.next=new Groups(name,k);
            currentg=currentg.next;
        }
    }
    public synchronized void addPolygon(String name,Polygon k){
        co++;
        if(currentp==null){
            currentp=new Polygons(name,k);
            headp=currentp;
        }
        else{
            currentp.next=new Polygons(name,k);
            currentp=currentp.next;
        }
    }
    public void addKugelb(String name,Kugel k){
        if(currentk==null){
            currentk=new Kugels(name,k);
            headk=currentk;
        }
        else{
            currentk.next=new Kugels(name,k);
            currentk=currentk.next;
        }
    }
    public void addGroupb(String name,Group k){
        if(currentg==null){
            currentg=new Groups(name,k);
            headg=currentg;
        }
        else{
            currentg.next=new Groups(name,k);
            currentg=currentg.next;
        }
    }
    public void addPolygonb(String name,Polygon k){
        co++;
        if(currentp==null){
            currentp=new Polygons(name,k);
            headp=currentp;
        }
        else{
            currentp.next=new Polygons(name,k);
            currentp=currentp.next;
        }
    }
    public synchronized Kugels getKugels(){
        if(headk==null)return null;
        return headk;
    }
    public synchronized Groups getGroups(){
        if(headg==null)return null;
        return headg;
    }
    public synchronized Polygons getPolygons(){
        if(headp==null)return null;
        return headp;
    }
    public Kugels getKugelsb(){
        if(headk==null)return null;
        return headk;
    }
    public Groups getGroupsb(){
        if(headg==null)return null;
        return headg;
    }
    public Polygons getPolygonsb(){
        if(headp==null)return null;
        return headp;
    }
    public synchronized void transform(double x,double y,double z){
        Kugels kug=getKugels();
        while(kug!=null){
            kug.k.transform(x,y,z);
            kug=kug.next;
        }
        Polygons pol=getPolygons();
        while(pol!=null){
            pol.p.transform(x,y,z);
            pol=pol.next;
        }
        Groups gop=getGroups();
        while(gop!=null){
            gop.g.transform(x,y,z);
            gop=gop.next;
        }
    }
    public void transformb(double x,double y,double z){
        Kugels kug=getKugels();
        while(kug!=null){
            kug.k.transform(x,y,z);
            kug=kug.next;
        }
        Polygons pol=getPolygons();
        while(pol!=null){
            pol.p.transform(x,y,z);
            pol=pol.next;
        }
        Groups gop=getGroups();
        while(gop!=null){
            gop.g.transform(x,y,z);
            gop=gop.next;
        }
    }
    public synchronized void rotLeft(double x){
        Kugels kug=getKugels();
        while(kug!=null){
            kug.k.rotLeft(x);
            kug=kug.next;
        }
        Polygons pol=getPolygons();
        while(pol!=null){
            pol.p.rotLeft(x);
            pol=pol.next;
        }
        Groups gop=getGroups();
        while(gop!=null){
            gop.g.rotLeft(x);
            gop=gop.next;
        }
    }
    public synchronized void rotUp(double x){
        Kugels kug=getKugels();
        while(kug!=null){
            kug.k.rotUp(x);
            kug=kug.next;
        }
        Polygons pol=getPolygons();
        while(pol!=null){
            pol.p.rotUp(x);
            pol=pol.next;
        }
        Groups gop=getGroups();
        while(gop!=null){
            gop.g.rotUp(x);
            gop=gop.next;
        }
    }
    public Vektor getCoord(Vektor v){
        double x=v.x;
        double y=v.y;
        double z=v.z;
        double vx=Math.atan(y/x)/(Math.PI/6)*200;
        double vy=Math.atan(z/x)/(Math.PI/6)*200;
        double vz=Math.sqrt(x*x+y*y+z*z);
        Vektor rvv=new Vektor(vx,vy,vz);
        rvv.xtra=v.x;
        return rvv;
    }
//    public void paint(Graphics g){
//    }
    public synchronized void paint(Graphics g){
        h.setColor(Color.white);
        h.fillRect(0,0,800,600);
        Pols current=null;
        Pols suc=null;
        Pols head=null;
        Polygons po=getPolygonsb();
        h.setColor(Color.blue);
        boolean first=true;
        boolean isWeg=false;
        int zet=0;
        while(po!=null){
            zet++;
            Color col=po.p.col;
            Veks ve=new Veks(getCoord(po.p.head.data));
            PolElem poe=po.p.head.next;
            current=new Pols(ve,col);
            if(suc!=null)suc.next=current;
            suc=current;
            isWeg=false;
            if(po.p.head.data.x<=1)isWeg=true;
            if(first){
                first=false;
                head=current;
            }
            int z=0;
            Veks ver=current.data;
            while(poe!=null){
                if(poe.data.x<=1)isWeg=true;
                Vektor v=getCoord(poe.data);
                ver.next=new Veks(v);
                ver=ver.next;
                poe=poe.next;
                z++;
            }
            current=current.next;
            po=po.next;
        }
        zet++;
        Groups go=getGroupsb();
        Groups gt=getGroupsb();
        int anzahlo=0;
        int anzu=0;
        while(gt!=null){
            GElem gz=gt.g.head;
            while(gz!=null){
                anzu++;
                gz=gz.next;
            }
        gt=gt.next;
        anzahlo++;
        }
        int polis=0;
        while(go!=null){
            Group gr=go.g;
            double d=gr.center().entf();
            GElem gpoi=gr.head;
            while(gpoi!=null){
                polis++;
                Polygon poi=gpoi.data;
                Color col=poi.col;
                PolElem poe=poi.head;
                Veks ve=new Veks(getCoord(poe.data));
                ve.data.z=d;
                poe=poe.next;
                current=new Pols(ve,col);
                if(suc!=null)suc.next=current;
                if(first){
                    first=false;
                    head=current;
                }
                Veks verz=current.data;
                while(poe!=null){
                    Vektor v=getCoord(poe.data);
                    v.z=d;
                    verz.next=new Veks(v);
                    verz=verz.next;
                    poe=poe.next;
                }
                suc=current;
                current=current.next;
                gpoi=gpoi.next;
            }
            go=go.next;
        }
        Kugels kul=getKugelsb();
        while(kul!=null){
            Veks vk=new Veks(getCoord(kul.k.mitte));
            current=new Pols(vk,new Color(0));
            if(first){
                head=current;
                first=false;
            }
            if(suc!=null)suc.next=current;
            current.data.k=kul.k;
            suc=current;
            current=current.next;
            kul=kul.next;
        }
        Pols cursor=head;
        Pols vore=null;
        cursor=head;
        int anzahlz=0;
        while(cursor!=null){
            anzahlz++;
            cursor=cursor.next;
        }
        cursor=head;
        while(cursor!=null){
            Veks veru=cursor.head;
            boolean verub=false;
            boolean left=false;
            boolean right=false;
            boolean left2=false;
            boolean right2=false;
            while(veru!=null){
                if(veru.data.x<200)left=true;
                if(veru.data.x>200)right=true;
                if(veru.data.y<200)left2=true;
                if(veru.data.y>200)right2=true;
//Variante: einzelne Polygonpunkte entfernen
//                if(veru.data.xtra<10)verub=true;
                veru=veru.next;
            }
            if(verub&&vore!=null){
                vore.next=cursor.next;
            }
            if(verub&&vore==null){
                head=head.next;
            }
            cursor=cursor.next;
            if(!verub)vore=cursor;
        }
        cursor=head;
        int anzahl=0;
        while(cursor!=null){
            anzahl++;
            cursor=cursor.next;
        }
        cursor=head;
        Pols[]veco=new Pols[anzahl];
        for(int i=0;i<anzahl;i++){
            veco[i]=cursor;
            cursor=cursor.next;
        }
        for(int i=0;i<anzahl;i++){
            double maximum=veco[i].data.data.z;
            int index=i;
            for(int j=i+1;j<anzahl;j++){
                if(veco[j].data.data.z>maximum){
                    index=j;
                    maximum=veco[j].data.data.z;
                }
            }
            Pols p=veco[i];
            veco[i]=veco[index];
            veco[index]=p;
        }
        for(int i=0;i<anzahl;i++){
            java.awt.Polygon pogy=new java.awt.Polygon();
            Veks veci=veco[i].data;
            int anz=0;
            boolean onepogi=false;
            while(veci!=null){
                pogy.addPoint((int)(200+veci.data.x),(int)(200+veci.data.y));
                if(veci.data.xtra<10){
                    onepogi=true;
                }
                veci=veci.next;
                anz++;
            }
            if(!onepogi){
                h.setColor(veco[i].col);
                h.fillPolygon(pogy);
            }
            if(veco[i].data.k!=null){
                Kugel kug=veco[i].data.k;
                Vektor mitte=getCoord(kug.mitte);
                h.setColor(kug.col);
                int heig=(int)(Math.atan(kug.radius/mitte.z)/(Math.PI/6)*200);
                if(kug.mitte.x>1){
                    h.fillOval((int)(200+mitte.x),(int)(200+mitte.y),heig,heig);
                }
            }
        }
        h.setColor(Color.black);
        h.drawString(status,10,90);
        g.drawImage(img,0,0,this);
//        paint(g);
    }
    public void setStatus(String s){
        status=s;
    }
    public void run(){
        try{
            while(running){
                Thread.sleep(100);
                repaint();
            }
        }
        catch(Exception e){
        }
    }
    public void stopEngine(){
        repaint();
        running=false;
    }
    public void findLoop(String inf){
        Groups cur=getGroups();
        Groups[]foundstart=new Groups[10000];
        int i=0;
        while(cur!=null&&i<10000){
            for(int j=0;j<i;j++){
                if(foundstart[j]==cur){
                    System.out.println(inf);
                    System.out.println("loop found: "+i+" "+j);
                    System.exit(0);
                }
            }
            foundstart[i]=cur;
            i++;
            cur=cur.next;
        }
    }
}
class ImageFrameTunnel extends JFrame{
    Image img;
    private static final long serialVersionUID = -9021582460204711624L;
    public ImageFrameTunnel(){
        pack();
        img=createImage(800,600);
    }
}
class Group{
    GElem head;
    GElem current;
    public Group(Polygon p){
        head=new GElem(p);
        current=head;
    }
    public GElem getHead(){
        return head;
    }
    public void addpol(Polygon nextd){
        current.next=new GElem(nextd);
        current=current.next;
    }
    public Group cloneo(){
        Group cl=new Group(head.data.cloneo());
        GElem pol=head;
        while(pol!=null){
            cl.addpol(pol.data.cloneo());
            pol=pol.next;
        }
        return cl;
    }
    public Vektor center(){
        GElem pol=head;
        int anzu=0;
        Vektor v=new Vektor(0,0,0);
        while(pol!=null){
            Vektor vk=pol.data.center();
            v.x+=vk.x;
            v.y+=vk.y;
            v.z+=vk.z;
            anzu++;
            pol=pol.next;
        }
        v.x/=anzu;
        v.y/=anzu;
        v.z/=anzu;
        return v;
    }
    public void transform(double a,double b,double c){
        GElem pol=head;
        while(pol!=null){
            pol.data.transform(a,b,c);
            pol=pol.next;
        }
    }
    public void setCoord(int coord,double a){
        GElem pol=head;
        while(pol!=null){
            pol.data.setCoord(coord,a);
            pol=pol.next;
        }
    }
    public void changeCoord(int coord1,int coord2){
        GElem pol=head;
        while(pol!=null){
            pol.data.changeCoord(coord1,coord2);
            pol=pol.next;
        }
    }
    public void rotLeft(double a){
        GElem pol=head;
        while(pol!=null){
            pol.data.rotLeft(a);
            pol=pol.next;
        }
    }
    public void rotUp(double a){
        GElem pol=head;
        while(pol!=null){
            pol.data.rotUp(a);
            pol=pol.next;
        }
    }
}
class GElem{
    Polygon data;
    GElem next;
    public GElem(Polygon data){
        this.data=data;
    }
    public Polygon getPolygon(){
        return data;
    }
    public GElem next(){
        return next;
    }
}
class PolElem{
    Vektor data;
    PolElem next;
    public PolElem(Vektor data){
        this.data=data;
    }
    public Vektor getVektor(){
        return data;
    }
    public PolElem next(){
        return next;
    }
}
class Polygon{
    Color col;
    PolElem head;
    PolElem current;
    public Polygon(Color col,Vektor first){
        this.col=col;
        head=new PolElem(first);
        current=head;
    }
    public Color getColor(){
        return col;
    }
    public PolElem getVektors(){
        return head;
    }
    public void addpoint(Vektor nextd){
        current.next=new PolElem(nextd);
        current=current.next;
    }
    public Vektor center(){
        PolElem s=head;
        Vektor center=new Vektor(0,0,0);
        int anze=0;
        while(s!=null){
            center.x+=s.data.x;
            center.y+=s.data.y;
            center.z+=s.data.z;
            s=s.next;
            anze++;
        }
        center.x/=anze;
        center.y/=anze;
        center.z/=anze;
        return center;
    }
    public Polygon cloneo(){
        Polygon cl=new Polygon(col,head.data.cloneo());
        PolElem pol=head;
        while(pol!=null){
            cl.addpoint(pol.data.cloneo());
            pol=pol.next;
        }
        return cl;
    }
    public void transform(double a,double b,double c){
        PolElem pol=head;
        while(pol!=null){
            pol.data.transform(a,b,c);
            pol=pol.next;
        }
    }
    public void setCoord(int coord,double a){
        PolElem pol=head;
        while(pol!=null){
            pol.data.setCoord(coord,a);
            pol=pol.next;
        }
    }
    public void changeCoord(int coord1,int coord2){
        PolElem pol=head;
        while(pol!=null){
            pol.data.changeCoord(coord1,coord2);
            pol=pol.next;
        }
    }
    public void rotLeft(double a){
        PolElem pol=head;
        while(pol!=null){
            pol.data.rotLeft(a);
            pol=pol.next;
        }
    }
    public void rotUp(double a){
        PolElem pol=head;
        while(pol!=null){
            pol.data.rotUp(a);
            pol=pol.next;
        }
    }
}
class Kugel{
    Color col;
    double radius;
    Vektor mitte;
    public Kugel(Vektor mitte,double radius,Color col){
        this.mitte=mitte;
        this.radius=radius;
        this.col=col;
    }
    public Color getColor(){
        return col;
    }
    public double getRadius(){
        return radius;
    }
    public Vektor getMitte(){
        return mitte;
    }
    public double entf(){
        return mitte.entf();
    }
    public void setCoord(int coord,double a){
        mitte.setCoord(coord,a);
    }
    public void changeCoord(int coord1,int coord2){
        mitte.changeCoord(coord1,coord2);
    }
    public Kugel cloneo(){
        return new Kugel(mitte.cloneo(),radius,col);
    }
    public void transform(double a,double b,double c){
        mitte.transform(a,b,c);
    }
    public void rotLeft(double a){
        mitte.rotLeft(a);
    }
    public void rotUp(double a){
        mitte.rotUp(a);
    }
}
class Vektor{
    double x,y,z;
    double xtra;
    public Vektor(double x,double y,double z){
        this.x=x;
        this.y=y;
        this.z=z;
    }
    public double getX(){
        return x;
    }
    public double getY(){
        return y;
    }
    public double getZ(){
        return z;
    }
    public double getXtra(){
        return xtra;
    }
    public Vektor cloneo(){
        Vektor cl=new Vektor(x,y,z);
        cl.xtra=xtra;
        return cl;
    }
    public void transform(double a,double b,double c){
        x+=a;
        y+=b;
        z+=c;
    }
    public void setCoord(int coord,double a){
        if(coord==1)x=a;
        else if(coord==2)y=a;
        else if(coord==2)z=a;
    }
    public void changeCoord(int coord1,int coord2){
        double temp=0;
        if((coord1==1&&coord2==2)||(coord1==2&&coord2==1)){
            temp=x;
            x=y;
            y=temp;
        }
        if((coord1==1&&coord2==3)||(coord1==3&&coord2==1)){
            temp=x;
            x=z;
            z=temp;
        }
        if((coord1==2&&coord2==3)||(coord1==3&&coord2==1)){
            temp=y;
            y=z;
            z=temp;
        }
    }
    public double entf(){
        return Math.sqrt(x*x+y*y+z*z);
    }
    public void rotLeft(double w){
        double win=0;
        if(x==0){
            if(y>0)win=Math.PI/2;
            else win=-Math.PI/2;
        }
        else{
            win=Math.atan(y/x);
        }
        if(x<0)win+=Math.PI;
        double len=Math.sqrt(x*x+y*y);
        win+=w;
        x=Math.cos(win)*len;
        y=Math.sin(win)*len;
    }
    public void rotUp(double w){
        double win=0;
        if(x==0){
            if(z>0)win=Math.PI/2;
            else win=-Math.PI/2;
        }
        else{
            win=Math.atan(z/x);
        }
        if(x<0)win+=Math.PI;
        double len=Math.sqrt(x*x+z*z);
        win+=w;
        x=Math.cos(win)*len;
        z=Math.sin(win)*len;
    }
}
